hmLoadTopic({
hmKeywords:"display filters,file filters,filters,ignore,ignore folder structure",
hmTitle:"Filtering the Folder Compare View",
hmDescription:"There are three overall type of filters you can use to control a Folder Compare session\'s scope:  File Filters that include or exclude files based on their name or attributes,...",
hmPrevLink:"dir_how_to_compare.html",
hmNextLink:"dir_reconciling_differences.html",
hmParentLink:"viewdir.html",
hmBreadCrumbs:"<a href=\"using_bc.html\">Using Beyond Compare<\/a> &gt; <a href=\"viewdir.html\">Folder Compare<\/a>",
hmTitlePath:"Using Beyond Compare > Folder Compare > Filtering the View",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">Filtering the Folder Compare View<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_Normal\">There are three overall type of filters you can use to control a Folder Compare session\'s scope:  <span class=\"f_Definition\">File Filters<\/span> that include or exclude files based on their name or attributes, <span class=\"f_Definition\">Display Filters<\/span> that show or hide lines of the comparison based on comparison status, and <span class=\"f_Definition\">Folder Display Filters<\/span> that control when folders appear.<\/p>\n\r<p class=\"p_Normal\">For instance, you can set the display filter to <span class=\"f_Command\">View &gt; Show Left Newer<\/span> <img style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/dirfavleftnewer.png\"\/> to display only those files that are newer on the left side of the comparison.  Or you can set a file filter to exclude *.bak files if you don\'t want to see or manipulate them.<\/p>\n\r<p class=\"p_Normal\">By default, commands that act on a selected folder\'s contents (such as Copy, Move, Delete, etc.) will respect the current filters.  That is, if the selection includes a folder, the folder\'s filtered-out contents are skipped.  To change this default behavior, pick <span class=\"f_Command\">Tools &gt; Options<\/span> <img style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/options.png\"\/>, switch to the <span class=\"f_Command\">File Operations<\/span> page, and mark the <span class=\"f_Command\">Include hidden items by default<\/span> checkbox.  In either case, action dialogs allow you to override the default behavior on a case-by-case basis.<\/p>\n\r<p class=\"p_Normal\">Pick <span class=\"f_Command\">View &gt; Suppress Filters<\/span> <img style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/suppressfilters.png\"\/> to temporarily suppress file filters and display filters.  Files and folders that were hidden will appear colored teal (blue-green) and can be processed.<\/p>\n\r<p class=\"p_Subtitle\"><span class=\"f_Subtitle\">File Filters<\/span><\/p>\n\r<p class=\"p_Normal\">You can specify the type of files you want to include in (or exclude from) the session.  For instance, if you are comparing Delphi projects you could include file types such as *.pas, *.dfm, and *.dpr.  Or, you could include all files except *.dcu and *.~* by excluding these file types.<\/p>\n\r<p class=\"p_Normal\">To specify a simple &quot;include these types&quot; filter, use the <span class=\"f_Command\">Filters<\/span> toolbar edit.  Enter the file types separated by semicolons, or use the dropdown list to select from presets.  Include a minus sign (-) in front of files to be excluded.<\/p>\n\r<p class=\"p_Normal\"><img style=\"margin:0;width:19.3125rem;height:1.6875rem;border:none\" src=\".\/images\/toolbarfilefilters.png\"\/><\/p>\n\r<p class=\"p_Normal\">In addition to these simple wildcard filters, you can specify more complex filters that include or exclude files or folders by name.  Pick <span class=\"f_Command\">Session &gt; Session Settings<\/span> <img style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/sessionedit.png\"\/>, and switch to the <span class=\"f_Command\">Name Filters<\/span> tab.  Or, simply click the <span class=\"f_Command\">Filters<\/span> <img style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/filters.png\"\/> toolbar button.<\/p>\n\r<p class=\"p_Normal\">Files can also be filtered based on their modified date, size, file attributes or text content.  In the Session Settings dialog, switch to the <span class=\"f_Command\">Other Filters<\/span> tab.  (Folders are not directly filtered based on their attributes, but are affected by the filtering of their contents.)<\/p>\n\r<p class=\"p_Subtitle\"><span class=\"f_Subtitle\">Display Filters<\/span><\/p>\n\r<p class=\"p_Normal\">Display filters limit the view to certain comparison results.  The comparison results are determined by the session\'s comparison rules.  For instance, you can pick <span class=\"f_Command\">View &gt; Show Differences<\/span> <img style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/favdiff.png\"\/> to remove all the matching files so that you can concentrate on the mismatches.<\/p>\n\r<p class=\"p_Normal\" style=\"margin: 0.6250rem 0 0.8750rem 0;\"><span class=\"f_Subtitle\">Folder Display Filters<\/span><\/p>\n\r<p class=\"p_Normal\">By default, folders only appear if at least one file they contain is visible.  However, you can switch to one of the other folder display filters.<\/p>\n\r<p class=\"p_Normal\"><span class=\"f_Command\">View &gt; Always Show Folders<\/span> <img style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/dirshowall.png\"\/> causes all folders to appear (unless they have been explicitly excluded by file filters), regardless of the other display filter selection.<\/p>\n\r<p class=\"p_Normal\"><span class=\"f_Command\">View &gt; Compare Files and Folder Structure<\/span> <img style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/dircomparestructure.png\"\/> causes folders to respect the display filters.  For example, if the main display filter is <span class=\"f_Command\">Show All<\/span> <img style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/favall.png\"\/> then all folders appear.  If it is <span class=\"f_Command\">Show Orphans<\/span> <img style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/dirfavorphan.png\"\/>, only orphan folders and folders that contain orphan files are shown.<\/p>\n\r<p class=\"p_Normal\"><span class=\"f_Command\">View &gt; Only Compare Files<\/span> <img style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/dircomparefilesonly.png\"\/> suppresses all empty folders, both truly empty folders and folders whose entire contents are hidden by other display or file filters.<\/p>\n\r<p class=\"p_Normal\"><span class=\"f_Command\">View &gt; Ignore Folder Structure<\/span> <img style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/dirflatten.png\"\/> hides the folder tree and aligns files regardless of what subfolder they are in.<\/p>\n\r<p class=\"p_SingleSpaced\"><span class=\"f_SeeAlso\">See also<\/span><\/p>\n\r<p class=\"p_SingleSpaced\"><a href=\"sessiondirnamefilter.html\" class=\"topiclink\">Folder Compare Name Filters<\/a><\/p>\n\r<p class=\"p_SingleSpaced\"><a href=\"sessiondirotherfilters.html\" class=\"topiclink\">Folder Compare Other Filters<\/a><\/p>\n\r<p class=\"p_SingleSpaced\"><a href=\"display_filters.html\" class=\"topiclink\">Display Filters<\/a><\/p>\n\r"
})
