hmLoadTopic({
hmKeywords:"compare contents,content comparison",
hmTitle:"Content Comparisons",
hmDescription:"In the Actions menu, the Compare Contents  command performs content comparisons on the selected pairs of files to determine if they match.",
hmPrevLink:"",
hmNextLink:"",
hmParentLink:"index.html",
hmBreadCrumbs:"",
hmTitlePath:"Glossary",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">Content Comparisons<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_Normal\">In the <span class=\"f_Command\">Actions<\/span> menu, the <span class=\"f_Command\">Compare Contents<\/span> <img style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/compare.png\"\/> command performs content comparisons on the selected pairs of files to determine if they match.<\/p>\n\r<p class=\"p_Subtitle\"><span class=\"f_Subtitle\">Content comparison methods<\/span><\/p>\n\r<p class=\"p_Normal\"><span class=\"f_Command\">CRC comparison<\/span> compares files using their CRC values.<\/p>\n\r<p class=\"p_Normal\"><span class=\"f_Command\">Binary comparison<\/span> compares files byte-by-byte.<\/p>\n\r<p class=\"p_Normal\"><span class=\"f_Command\">Rules-based comparison<\/span> compares files based on their <a href=\"file_formats.html\" class=\"topiclink\">file format<\/a> associations.  It allows you to define unimportant differences, such as changes in whitespace or source code comments.  A rules-based comparison can also ignore differences in file encoding or line endings.<\/p>\n\r<p class=\"p_Subtitle\"><span class=\"f_Subtitle\">Results of content comparisons<\/span><\/p>\n\r<p class=\"p_Normal\">CRC and Binary comparisons return one of these results:<\/p>\n\r<div style=\"text-align: left; text-indent: 0; padding: 0 0 0 0; margin: 0.1875rem 0 0.8750rem 0;\"><table style=\"border:none; border-spacing:0;\">\n\r<tr>\n\r<td style=\"vertical-align:top; width:2.2500rem; padding:0; border:none\"><p class=\"p_Normal\"><img style=\"margin:0;width:1.7500rem;height:1.0000rem;border:none\" src=\".\/images\/contentsamebinary.png\"\/><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:top; width:8.7500rem; padding:0; border:none\"><p class=\"p_Normal\">Binary same<\/p>\n\r<\/td>\n\r<td style=\"vertical-align:top; padding:0; border:none\"><p class=\"p_Normal\">The files are exactly the same.<\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:top; width:2.2500rem; padding:0; border:none\"><p class=\"p_Normal\"><img style=\"margin:0;width:1.7500rem;height:1.0000rem;border:none\" src=\".\/images\/contentdifferentbinary.png\"\/><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:top; width:8.7500rem; padding:0; border:none\"><p class=\"p_Normal\">Binary differences<\/p>\n\r<\/td>\n\r<td style=\"vertical-align:top; padding:0; border:none\"><p class=\"p_Normal\">At least one byte is different between the files.<\/p>\n\r<\/td>\n\r<\/tr>\n\r<\/table>\n\r<\/div>\n\r<p class=\"p_Normal\">Rules-based comparisons have a built-in binary comparison and return one of these results:<\/p>\n\r<div style=\"text-align: left; text-indent: 0; padding: 0 0 0 0; margin: 0.1875rem 0 0.8750rem 0;\"><table style=\"border:none; border-spacing:0;\">\n\r<tr>\n\r<td style=\"vertical-align:top; width:2.2500rem; padding:0; border:none\"><p class=\"p_Normal\"><img style=\"margin:0;width:1.7500rem;height:1.0000rem;border:none\" src=\".\/images\/contentsamebinary.png\"\/><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:top; width:8.7500rem; padding:0; border:none\"><p class=\"p_Normal\">Binary same<\/p>\n\r<\/td>\n\r<td style=\"vertical-align:top; padding:0; border:none\"><p class=\"p_Normal\">The files are exactly the same.<\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:top; width:2.2500rem; padding:0; border:none\"><p class=\"p_Normal\"><img style=\"margin:0;width:1.7500rem;height:1.0000rem;border:none\" src=\".\/images\/contentsame.png\"\/><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:top; width:8.7500rem; padding:0; border:none\"><p class=\"p_Normal\">Rules-based same<\/p>\n\r<\/td>\n\r<td style=\"vertical-align:top; padding:0; border:none\"><p class=\"p_Normal\">The files have binary differences, such as character encoding, that can be ignored.<\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:top; width:2.2500rem; padding:0; border:none\"><p class=\"p_Normal\"><img style=\"margin:0;width:1.7500rem;height:1.0000rem;border:none\" src=\".\/images\/contentsimilar.png\"\/><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:top; width:8.7500rem; padding:0; border:none\"><p class=\"p_Normal\">Unimportant differences<\/p>\n\r<\/td>\n\r<td style=\"vertical-align:top; padding:0; border:none\"><p class=\"p_Normal\">A rules-based comparison found only unimportant differences.<\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:top; width:2.2500rem; padding:0; border:none\"><p class=\"p_Normal\"><img style=\"margin:0;width:1.7500rem;height:1.0000rem;border:none\" src=\".\/images\/contentdifferent.png\"\/><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:top; width:8.7500rem; padding:0; border:none\"><p class=\"p_Normal\">Important differences<\/p>\n\r<\/td>\n\r<td style=\"vertical-align:top; padding:0; border:none\"><p class=\"p_Normal\">A rules-based comparison found important differences.<\/p>\n\r<\/td>\n\r<\/tr>\n\r<\/table>\n\r<\/div>\n\r<p class=\"p_Subtitle\"><span class=\"f_Subtitle\">When content comparisons are performed<\/span><\/p>\n\r<p class=\"p_Normal\">Content comparisons are performed:<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span>when a folder session is loaded, and its session settings call for automatic content comparisons<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span>explicitly, when the <span class=\"f_Command\">Compare Contents<\/span> <img style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/compare.png\"\/> command is used<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span>when a pair of files is opened in a file session<\/p>"
})
