hmLoadTopic({
hmKeywords:"FTP,FTP listing format",
hmTitle:"FTP Profile Listing Settings",
hmDescription:"Beyond Compare parses the plain text directory listings sent from the FTP server in order to determine the remote folder structure.  Unfortunately, there is no one standard for...",
hmPrevLink:"profileftpproxy.html",
hmNextLink:"profileftptransfer.html",
hmParentLink:"profileftp.html",
hmBreadCrumbs:"<a href=\"settings_reference.html\">Settings Reference<\/a> &gt; <a href=\"dlgprofilemanager.html\">Profiles<\/a> &gt; <a href=\"profileftp.html\">FTP Profiles<\/a>",
hmTitlePath:"Settings Reference > Profiles > FTP Profiles > Listings",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">FTP Profile Listing Settings<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_Normal\">Beyond Compare parses the plain text directory listings sent from the FTP server in order to determine the remote folder structure.  Unfortunately, there is no one standard for these listings.<\/p>\n\r<p class=\"p_Normal\">These settings help Beyond Compare understand the conventions and capabilities of the FTP server.<\/p>\n\r<p class=\"p_Subtitle\"><span class=\"f_Subtitle\">Link resolution<\/span><\/p>\n\r<p class=\"p_Normal\">FTP sites can connect files together using symbolic &quot;links&quot; which point from one area of the site to another.  These links do not specify whether they point to files or folders, so the following methods of resolving are available:<\/p>\n\r<p class=\"p_Command\"><span class=\"f_Command\">Fast<\/span><\/p>\n\r<p class=\"p_Normal\">Mark to treat any link which has an extension (e.g. &quot;.txt&quot;) as a file and all others as folders.  This requires no extra transfers.<\/p>\n\r<p class=\"p_Command\"><span class=\"f_Command\">Simple<\/span><\/p>\n\r<p class=\"p_Normal\">Mark to attempt to change folders into every link as it encounters it.  If it succeeds the link is considered a folder, otherwise it is considered a file.<\/p>\n\r<p class=\"p_Subtitle\"><span class=\"f_Subtitle\">LIST options<\/span><\/p>\n\r<p class=\"p_Command\"><span class=\"f_Command\">Use MLSD command<\/span><\/p>\n\r<p class=\"p_Normal\">Mark to request high-resolution timestamps from the server.  If successful, the following settings are ignored.  Soft links will be listed as plain files and folders, and listings won\'t be recursive.<\/p>\n\r<p class=\"p_Command\"><span class=\"f_Command\">Show hidden [-a]<\/span><\/p>\n\r<p class=\"p_Normal\">Mark to make the FTP server include files that it wouldn\'t normally include, such as Unix filenames that begin with a period.<\/p>\n\r<p class=\"p_Command\"><span class=\"f_Command\">Force long format [-l]<\/span><\/p>\n\r<p class=\"p_Normal\">Mark to attempt to change the output of the FTP server list command.  Try this option if Beyond Compare doesn\'t list any files when it loads.<\/p>\n\r<p class=\"p_Command\"><span class=\"f_Command\">Complete timestamps [-T]<\/span><\/p>\n\r<p class=\"p_Normal\">Mark to expand the timestamps that the FTP server returns to include a full date and time, including seconds.<\/p>\n\r<p class=\"p_Command\"><span class=\"f_Command\">Resolve links [-L]<\/span><\/p>\n\r<p class=\"p_Normal\">Mark to make the FTP server list soft links as plain files and folders with the timestamp and size of the link\'s target.<\/p>\n\r<p class=\"p_Command\"><span class=\"f_Command\">Recursive [-R]<\/span><\/p>\n\r<p class=\"p_Normal\">Mark to make directory listings recursive, including contents of the subfolders in response to a single FTP list command.  Recursive listings may be slower initially, but save time overall if subfolders will need to be examined eventually.<\/p>\n\r<p class=\"p_Subtitle\"><span class=\"f_Subtitle\">Miscellaneous settings<\/span><\/p>\n\r<p class=\"p_Command\"><span class=\"f_Command\">Hide VMS versions<\/span><\/p>\n\r<p class=\"p_Normal\">Mark to only include the most recent version of a file and align it with a local file.  Otherwise, all versions of the file are included with their version numbers.<\/p>\n\r<p class=\"p_Command\"><span class=\"f_Command\">Fetch incomplete timestamps<\/span><\/p>\n\r<p class=\"p_Normal\">Mark to try to fetch the file\'s last modified time in cases where the directory listing only reports the date.  This will provide more accurate timestamp comparisons at the cost of some performance.  Not supported on all FTP servers.<\/p>\n\r<p class=\"p_Normal\"><img style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/> <span class=\"f_NotePrompt\">Note<\/span>  If you need help with the settings on this page, consult your system administrator.<\/p>\n\r"
})
